#ifndef LOGIC_H_INCL
#define LOGIC_H_INCL

#include "main.h"


#define MANIFEST_APPNAME                 "Deprecit Lord Of Charge - LD48 #32"
#define MANIFEST_OPENGL_MAJOR            3
#define MANIFEST_OPENGL_MINOR            3
#define MANIFEST_OPENGL_CORE_CONTEXT     0      // 1 sucks on windows, and is necessary on mac and probably necessary on linux.
#define MANIFEST_OPENGL_FORWARD_COMPAT   0      // 1 is necessary on mac, sucks on windows and probably sucks on linux.
#define MANIFEST_WINDOW_W                1024
#define MANIFEST_WINDOW_H                768
#define MANIFEST_WINDOW_RESIZABLE        1
#define MANIFEST_WINDOW_INITIAL_STATE    1      // 0 for windowed, 1 for maximized, 2 for fullscreen
#define MANIFEST_WINDOW_ENABLE_ALT_ENTER 1      // Enable fullscreen toggle with Alt+Enter
#define MANIFEST_MSAA                    0      // Alnialiasing. 0 and 1 are same and mean no antialiasing. Possible values: 0, 1, 2, 4, 8, 16.
#define MANIFEST_AUDIO_SRCS              128    // Maximum amount of audio sources, don't touch it.
#define MANIFEST_AUDIO_SRCS_STEREO       32    // Maximum amount of audio stereo sources, don't touch it.
#define MANIFEST_AUDIO_SPEED_OF_SOUND    343.3f
#define MANIFEST_AUDIO_DOPPLER_FACTOR    1.0f
#define MANIFEST_AUDIO_REF_DISTANCE      300    // Aka nearest possible distance for audio sources. If distance is lesser than it, volume is maxed.
#define MANIFEST_AUDIO_MAX_DISTANCE      1800   // Aka largest clamping distance. If distance is larger than it, volume won't change.
#define MANIFEST_AUDIO_ROLLOFF_FACTOR    1.0f   // Increases speed at which sound get quieter.

namespace Prog
{
	void Init(int w, int h);
	void Resize(int w, int h);



	namespace States
	{
		Main::StateFunc Boot();
		Main::StateFunc Menu();
		Main::StateFunc World();
		Main::StateFunc Config();
	}
}


#endif