#include "shaders.h"

namespace ShaderCode
{
	namespace Colored
	{
		const char *const v = 1+R"(
#version 330

uniform mat4 u_mat_final = mat4(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1);

layout(location = 0) in vec3 in_pos;
layout(location = 1) in vec4 in_c;


out vec4 m_c;

void main()
{
	m_c = in_c;
	gl_Position = vec4(in_pos, 1.0f) * u_mat_final;
}
)";
		const char *const f = 1+R"(
#version 330

in vec4 m_c;

out vec4 out_color;

void main()
{
	out_color = m_c;
}
)";

	}

	namespace Textured
	{
		const char *const v = 1+R"(
#version 330

uniform mat4 u_mat_final = mat4(1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1, 0, 0, 0, 0, 1);
uniform sampler2D t;

layout(location = 0) in vec3 in_pos;
layout(location = 1) in vec2 in_tc;
layout(location = 2) in vec4 in_co;
layout(location = 3) in vec4 in_cm;

out vec2 m_tc;
out vec4 m_co;
out vec4 m_cm;

void main()
{
	m_co = in_co;
	m_cm = in_cm;
	m_tc = in_tc / textureSize(t, 0);
	gl_Position = vec4(in_pos, 1.0f) * u_mat_final;
}
)";
		const char *const f = 1+R"(
#version 330

uniform vec4 u_co = vec4(0,0,0,0);
uniform vec4 u_cm = vec4(1,1,1,1);
uniform sampler2D t;

in vec2 m_tc;
in vec4 m_co;
in vec4 m_cm;

out vec4 out_color;

void main()
{
	out_color = (texture(t, m_tc) * m_cm + m_co) * u_cm + u_co;
}
)";

	}
}