#include "utils.h"

namespace Utils
{
	std::stringstream UC::ss;

	const char *Str(std::initializer_list<UC> data)
	{
		static std::string ret;
		ret = "";
		for (auto it = data.begin(); it != data.end(); it++)
		{
			ret += it->str;
		}
		return ret.c_str();
	}

	namespace RNG
	{
		static std::mt19937 gen32;
		static std::mt19937_64 gen64;
		std::mt19937::result_type x32()
		{
			return gen32();
		}
		std::mt19937_64::result_type x64()
		{
			return gen64();
		}
		void x32_discard(unsigned int count)
		{
			gen32.discard(count);
		}
		void x64_discard(unsigned int count)
		{
			gen64.discard(count);
		}
		void x32_seed(std::mt19937::result_type p)
		{
			gen32.seed(p);
		}
		void x64_seed(std::mt19937_64::result_type p)
		{
			gen64.seed(p);
		}
	}
}

const float fPi = std::atan(1) * 4;
const double dPi = std::atan(1) * 4;
const float fPi2 = fPi * 2.0f;
const double dPi2 = dPi * 2.0f;
const float fPi_half = fPi / 2.0f;
const double dPi_half = dPi / 2.0f;
const float fPi_quarter = fPi / 4.0f;
const double dPi_quarter = dPi / 4.0f;